Index: /trunk/src/org/expeditee/gui/FrameMouseActions.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameMouseActions.java	(revision 120)
+++ /trunk/src/org/expeditee/gui/FrameMouseActions.java	(revision 121)
@@ -165,5 +165,5 @@
 				public void actionPerformed(ActionEvent ae) {
 					// check if we are in free space
-					if (_lastClickedOn == null && Frame.FreeItems.size() == 0) {
+					if (_lastClickedOn == null && FreeItems.getInstance().size() == 0) {
 						// System.out.println("SuperBack!");
 						_MouseTimer.setDelay(ZERO_MOUSE_PAUSE);
@@ -172,6 +172,6 @@
 						if (FrameUtils.getCurrentItem() == null) {
 							// Check if we are toggling arrowhead
-							if (Frame.FreeItems.size() <= 2) {
-								for (Item i : Frame.FreeItems) {
+							if (FreeItems.getInstance().size() <= 2) {
+								for (Item i : FreeItems.getInstance()) {
 									if (i instanceof Line) {
 										((Line) i).toggleArrow();
@@ -273,10 +273,10 @@
 		// the other
 		// Long depress actions if that is what is wanted.
-		if (_lastClickedOn == null && Frame.FreeItems.size() == 0) {
+		if (_lastClickedOn == null && FreeItems.getInstance().size() == 0) {
 			// System.out.println(e.getClickCount());
 			if (e.getClickCount() >= 2) {
 				_MouseTimer.start();
 			}
-		} else if (_lastClickedOn != null && Frame.FreeItems.size() == 0
+		} else if (_lastClickedOn != null && FreeItems.getInstance().size() == 0
 				&& e.getButton() == MouseEvent.BUTTON3) {
 			_ExtrudeMouseTimer.start();
@@ -318,5 +318,5 @@
 
 			_lastHighlightedItem = Frame.getItemAttachedToCursor();
-			for (Item i : Frame.FreeItems) {
+			for (Item i : FreeItems.getInstance()) {
 				i.setHighlightColor(Item.DEPRESSED_HIGHLIGHT);
 			}
@@ -438,9 +438,9 @@
 
 			if (Frame.itemAttachedToCursor()) {
-				move(Frame.FreeItems);
-			}
-
-			FrameGraphics
-					.DisplayMessage("Action cancelled, mouse moved more than "
+				move(FreeItems.getInstance());
+			}
+
+			MessageBay
+					.displayMessage("Action cancelled, mouse moved more than "
 							+ UserSettings.NoOpThreshold + " pixels.");
 			FrameGraphics.Repaint();
@@ -456,5 +456,5 @@
 				if (i != null && i instanceof Text) {
 					lastRanged.replaceSelectedText(((Text) i).getText());
-					Frame.FreeItems.clear();
+					FreeItems.getInstance().clear();
 				} else
 					lastRanged.cutSelectedText();
@@ -504,6 +504,6 @@
 				if (!lastRanged.hasPermission(Permission.full)
 						|| lastRanged.isFrameName()) {
-					FrameGraphics
-							.DisplayMessage("Insufficient permission to cut text");
+					MessageBay
+							.displayMessage("Insufficient permission to cut text");
 					lastRanged.clearSelection();
 					FrameGraphics.Repaint();
@@ -524,6 +524,6 @@
 				// do not have permission to do so... or it is the frame name
 				if (!lastRanged.hasPermission(Permission.copy)) {
-					FrameGraphics
-							.DisplayMessage("Insufficient permission to copy text");
+					MessageBay
+							.displayMessage("Insufficient permission to copy text");
 					lastRanged.clearSelection();
 					FrameGraphics.Repaint();
@@ -628,6 +628,6 @@
 			// check item permissions
 			if (!clicked.hasPermission(Permission.followLinks)) {
-				FrameGraphics
-						.DisplayMessage("Insufficient permissions to perform action on item");
+				MessageBay
+						.displayMessage("Insufficient permissions to perform action on item");
 				return;
 			}
@@ -658,6 +658,6 @@
 				// check for TDFC permission
 				if (!clicked.hasPermission(Permission.createFrames)) {
-					FrameGraphics
-							.DisplayMessage("Insufficient permission to TDFC from that item");
+					MessageBay
+							.displayMessage("Insufficient permission to TDFC from that item");
 					return;
 				}
@@ -675,5 +675,5 @@
 					tdfc(clickedOn);
 				} catch (RuntimeException e) {
-					FrameGraphics.ErrorMessage(e.getMessage());
+					MessageBay.errorMessage(e.getMessage());
 				}
 				return;
@@ -698,5 +698,5 @@
 			return false;
 
-		// System.out.println(Frame.FreeItems.size());
+		// System.out.println(FreeItems.getInstance().size());
 		if (isRubberBandingCorner()) {
 			if (clicked.isLineEnd()
@@ -707,5 +707,5 @@
 		}
 
-		if (Frame.FreeItems.size() > 2)
+		if (FreeItems.getInstance().size() > 2)
 			return false;
 
@@ -734,13 +734,13 @@
 						&& clicked.getParent() != null
 						&& clicked.getParent().getNameItem() != clicked) {
-					FrameGraphics.DisplayMessage("Insufficient permission");
+					MessageBay.displayMessage("Insufficient permission");
 					return;
 				}
 
-				Item merger = Frame.FreeItems.get(0);
+				Item merger = FreeItems.getInstance().get(0);
 				assert (merger != null);
-				Collection<Item> left = merge(Frame.FreeItems, clicked);
+				Collection<Item> left = merge(FreeItems.getInstance(), clicked);
 				anchor(left);
-				Frame.FreeItems.clear();
+				FreeItems.getInstance().clear();
 				FrameGraphics.Repaint();
 				updateCursor();
@@ -750,6 +750,6 @@
 				// if a line is being rubber-banded, check for auto
 				// straightening
-				anchor(Frame.FreeItems);
-				Frame.FreeItems.clear();
+				anchor(FreeItems.getInstance());
+				FreeItems.getInstance().clear();
 				updateCursor();
 				_offX = _offY = 0;
@@ -760,6 +760,6 @@
 			// check permissions
 			if (!clicked.hasPermission(Permission.full)) {
-				FrameGraphics
-						.DisplayMessage("Insufficient permission to pick up item");
+				MessageBay
+						.displayMessage("Insufficient permission to pick up item");
 				return;
 			}
@@ -885,9 +885,9 @@
 			return;
 		}
-		SessionStats.MovedItems(Frame.FreeItems);
+		SessionStats.MovedItems(FreeItems.getInstance());
 	}
 
 	private static Item getFirstFreeLineEnd() {
-		for (Item i : Frame.FreeItems)
+		for (Item i : FreeItems.getInstance())
 			if (i.isLineEnd())
 				return i;
@@ -896,5 +896,5 @@
 
 	private static boolean isRubberBandingCorner() {
-		return getShapeCorner(Frame.FreeItems) != null;
+		return getShapeCorner(FreeItems.getInstance()) != null;
 	}
 
@@ -949,6 +949,6 @@
 				if (!clicked.hasPermission(Permission.full)
 						&& clicked.getParent().getNameItem() != clicked) {
-					FrameGraphics
-							.DisplayMessage("Insufficient permission to merge items");
+					MessageBay
+							.displayMessage("Insufficient permission to merge items");
 					return;
 				}
@@ -988,21 +988,21 @@
 						copies = copy(toCopy);
 						// Now do the merging
-						Collection<Item> remain = merge(Frame.FreeItems,
+						Collection<Item> remain = merge(FreeItems.getInstance(),
 								clicked);
 						// anchor the points
 						anchor(remain);
-						Frame.FreeItems.clear();
+						FreeItems.getInstance().clear();
 						pickup(copies);
 						// line onto something
-					} else if (Frame.FreeItems.size() == 2
+					} else if (FreeItems.getInstance().size() == 2
 					/* && clicked instanceof XRayable */) {
-						copies = ItemUtils.UnreelLine(Frame.FreeItems,
+						copies = ItemUtils.UnreelLine(FreeItems.getInstance(),
 								_controlDown);
-						Collection<Item> leftOver = merge(Frame.FreeItems,
+						Collection<Item> leftOver = merge(FreeItems.getInstance(),
 								clicked);
 						anchor(leftOver);
 						if (copies == null)
-							copies = copy(Frame.FreeItems);
-						Frame.FreeItems.clear();
+							copies = copy(FreeItems.getInstance());
+						FreeItems.getInstance().clear();
 						for (Item i : copies)
 							i.setOffset(0, 0);
@@ -1011,6 +1011,6 @@
 						pickup(copies);
 						// point onto point
-					} else if (Frame.FreeItems.size() == 1) {
-						copies = copy(Frame.FreeItems);
+					} else if (FreeItems.getInstance().size() == 1) {
+						copies = copy(FreeItems.getInstance());
 						Collection<Item> remain = merge(copies, clicked);
 
@@ -1019,16 +1019,16 @@
 					} else {
 						stampItemsOnCursor();
-						copies = Frame.FreeItems;
+						copies = FreeItems.getInstance();
 					}
 				} else {
 					copies = ItemUtils
-							.UnreelLine(Frame.FreeItems, _controlDown);
+							.UnreelLine(FreeItems.getInstance(), _controlDown);
 					if (copies == null)
-						copies = copy(Frame.FreeItems);
+						copies = copy(FreeItems.getInstance());
 					for (Item i : copies) {
 						i.setOffset(0, 0);
 					}
-					anchor(Frame.FreeItems);
-					Frame.FreeItems.clear();
+					anchor(FreeItems.getInstance());
+					FreeItems.getInstance().clear();
 					pickup(copies);
 				}
@@ -1039,6 +1039,6 @@
 					Item d = getFirstFreeLineEnd();
 					// anchor the points
-					anchor(Frame.FreeItems);
-					Frame.FreeItems.clear();
+					anchor(FreeItems.getInstance());
+					FreeItems.getInstance().clear();
 					updateCursor();
 					// pick up a copy of all enclosed items
@@ -1083,5 +1083,5 @@
 					if (rubberBanding()) {
 						if (clicked != null) {
-							Collection<Item> leftOver = merge(Frame.FreeItems,
+							Collection<Item> leftOver = merge(FreeItems.getInstance(),
 									clicked);
 							anchor(leftOver);
@@ -1089,10 +1089,10 @@
 						// This is executed when the user is putting down a line
 						// endpoint and unreeling. ie. Normal unreeling
-						copies = ItemUtils.UnreelLine(Frame.FreeItems,
+						copies = ItemUtils.UnreelLine(FreeItems.getInstance(),
 								_controlDown);
 
 						if (copies == null)
-							copies = copy(Frame.FreeItems);
-						anchor(Frame.FreeItems);
+							copies = copy(FreeItems.getInstance());
+						anchor(FreeItems.getInstance());
 						for (Item i : copies)
 							i.setOffset(0, 0);
@@ -1104,5 +1104,5 @@
 						// remove any lines that dont have both endpoints
 						// floating
-						for (Item i : Frame.FreeItems) {
+						for (Item i : FreeItems.getInstance()) {
 							if (i.isFloating())
 								originals.add(i);
@@ -1112,5 +1112,5 @@
 						for (Item i : copies)
 							i.setOffset(0, 0);
-						anchor(Frame.FreeItems);
+						anchor(FreeItems.getInstance());
 						// Move isnt working right for extruding!!
 						// move(copies);
@@ -1118,5 +1118,5 @@
 					} else {
 						stampItemsOnCursor();
-						copies = Frame.FreeItems;
+						copies = FreeItems.getInstance();
 					}
 				}
@@ -1127,6 +1127,6 @@
 				// check permissions
 				if (!clicked.hasPermission(Permission.copy)) {
-					FrameGraphics
-							.DisplayMessage("Insufficient permission to copy item");
+					MessageBay
+							.displayMessage("Insufficient permission to copy item");
 					return;
 				}
@@ -1164,6 +1164,6 @@
 					Collection<Item> enclosed = getFullyEnclosedItems(clickedIn);
 					if (enclosed.size() == 0) {
-						FrameGraphics
-								.DisplayMessage("Insufficient permission to copy items");
+						MessageBay
+								.displayMessage("Insufficient permission to copy items");
 					} else {
 						copies = copy(enclosed);
@@ -1202,5 +1202,5 @@
 						merge(toMerge, on);
 						// anchor(left);
-						// Frame.FreeItems.clear();
+						// FreeItems.getInstance().clear();
 						FrameGraphics.Repaint();
 						updateCursor();
@@ -1251,5 +1251,5 @@
 	 */
 	private static void stampItemsOnCursor() {
-		List<Item> copies = copy(Frame.FreeItems);
+		List<Item> copies = copy(FreeItems.getInstance());
 		// MIKE: what does the below 2 lines do?
 		for (Item i : copies)
@@ -1257,5 +1257,5 @@
 		// The below code has a little problem withflicker when stamp
 		// and dragging
-		move(Frame.FreeItems);
+		move(FreeItems.getInstance());
 		for (Item i : copies) {
 			i.setHighlightMode(HighlightMode.None);
@@ -1379,5 +1379,5 @@
 					e.getY());
 
-			if (Frame.FreeItems.size() == 0) {
+			if (FreeItems.getInstance().size() == 0) {
 				// if the user can spot-weld, show the virtual spot
 				if (on instanceof Line) {
@@ -1454,5 +1454,5 @@
 			// Wait until the last Robot mouse move event arrives before
 			// processing other events
-			if (/* Frame.FreeItems.size() == 0 || */
+			if (/* FreeItems.getInstance().size() == 0 || */
 			(LastRobotX == e.getX() && LastRobotY == e.getY())) {
 				LastRobotX = null;
@@ -1460,5 +1460,5 @@
 				_RobotTimer.stop();
 			} else {
-				// System.out.println("Ignored: " + Frame.FreeItems.size());
+				// System.out.println("Ignored: " + FreeItems.getInstance().size());
 				return;
 			}
@@ -1477,14 +1477,14 @@
 
 		// If shift is down then the movement is constrained
-		if (_controlDown && Frame.FreeItems.size() > 0) {
+		if (_controlDown && FreeItems.getInstance().size() > 0) {
 			// Check if we are rubber banding a line
 			if (shiftStateChanged && rubberBanding()) {
 				// Get the line end that is being rubber banded
-				Item thisEnd = Frame.FreeItems.get(0).isLineEnd() ? Frame.FreeItems
+				Item thisEnd = FreeItems.getInstance().get(0).isLineEnd() ? FreeItems.getInstance()
 						.get(0)
-						: Frame.FreeItems.get(1);
-				Line line = (Line) (Frame.FreeItems.get(0).isLineEnd() ? Frame.FreeItems
+						: FreeItems.getInstance().get(1);
+				Line line = (Line) (FreeItems.getInstance().get(0).isLineEnd() ? FreeItems.getInstance()
 						.get(1)
-						: Frame.FreeItems.get(0));
+						: FreeItems.getInstance().get(0));
 				Item otherEnd = line.getOppositeEnd(thisEnd);
 				int deltaX = Math.abs(e.getX() - otherEnd.getX());
@@ -1533,7 +1533,7 @@
 			}// If its a lineend attached to two lines lengthen the shorter
 			// so it is the same length as the longer line
-			else if (Frame.FreeItems.size() == 3) {
+			else if (FreeItems.getInstance().size() == 3) {
 				// check if we are rubber banding the corner of a shape
-				Item thisEnd = getShapeCorner(Frame.FreeItems);
+				Item thisEnd = getShapeCorner(FreeItems.getInstance());
 				if (thisEnd != null) {
 					Line line1 = thisEnd.getLines().get(0);
@@ -1614,6 +1614,6 @@
 		} else if (shiftStateChanged && !_controlDown && rubberBanding()) {
 			// Get the line end that is being rubber banded
-			Item thisEnd = Frame.FreeItems.get(0).isLineEnd() ? Frame.FreeItems
-					.get(0) : Frame.FreeItems.get(1);
+			Item thisEnd = FreeItems.getInstance().get(0).isLineEnd() ? FreeItems.getInstance()
+					.get(0) : FreeItems.getInstance().get(1);
 			thisEnd.removeAllConstraints();
 		}
@@ -1627,6 +1627,6 @@
 
 		if (Frame.itemAttachedToCursor()) {
-			move(Frame.FreeItems);
-			// System.out.println(Frame.FreeItems.size());
+			move(FreeItems.getInstance());
+			// System.out.println(FreeItems.getInstance().size());
 		}
 
@@ -1652,5 +1652,5 @@
 				_context = CONTEXT_AT_TEXT;
 			}
-			if (Frame.FreeItems.size() > 0)
+			if (FreeItems.getInstance().size() > 0)
 				_alpha = 60;
 			else
@@ -1662,10 +1662,10 @@
 
 		// if the user is pointing at an item, highlight it
-		if (on != null && !Frame.FreeItems.contains(on)) {
+		if (on != null && !FreeItems.getInstance().contains(on)) {
 			// if the user can spot-weld, show the virtual spot
-			if (Frame.FreeItems.size() == 2 && on instanceof Line) {
+			if (FreeItems.getInstance().size() == 2 && on instanceof Line) {
 				Line line = (Line) on;
-				Item freeItem0 = Frame.FreeItems.get(0);
-				Item freeItem1 = Frame.FreeItems.get(1);
+				Item freeItem0 = FreeItems.getInstance().get(0);
+				Item freeItem1 = FreeItems.getInstance().get(1);
 				Item lineEnd = freeItem0.isLineEnd() ? freeItem0 : (freeItem1
 						.isLineEnd() ? freeItem1 : null);
@@ -1702,5 +1702,5 @@
 				// check that the enclosure is not part of a point being
 						// dragged in space
-						!ContainsOneOf(enclosure, Frame.FreeItems)) {
+						!ContainsOneOf(enclosure, FreeItems.getInstance())) {
 					on = firstLineEnd.getLines().get(0);
 					// System.out.println(on == null ? "Null" :
@@ -1760,5 +1760,5 @@
 	 */
 	private static boolean rubberBanding() {
-		if (Frame.FreeItems.size() != 2) {
+		if (FreeItems.getInstance().size() != 2) {
 			return false;
 		}
@@ -1766,5 +1766,5 @@
 		// if rubber-banding, there will be 1 lineend and the rest will be lines
 		boolean foundLineEnd = false;
-		for (Item i : Frame.FreeItems) {
+		for (Item i : FreeItems.getInstance()) {
 			if (i.isLineEnd()) {
 				if (foundLineEnd) {
@@ -1803,8 +1803,8 @@
 	public static void resetOffset() {
 		if (Frame.itemAttachedToCursor()) {
-			_offX = DisplayIO.getMouseX() - Frame.FreeItems.get(0).getX()
-					+ Frame.FreeItems.get(0).getOffset().x;
-			_offY = getY() - Frame.FreeItems.get(0).getY()
-					+ Frame.FreeItems.get(0).getOffset().y;
+			_offX = DisplayIO.getMouseX() - FreeItems.getInstance().get(0).getX()
+					+ FreeItems.getInstance().get(0).getOffset().x;
+			_offY = getY() - FreeItems.getInstance().get(0).getY()
+					+ FreeItems.getInstance().get(0).getOffset().y;
 		}
 	}
@@ -1835,5 +1835,5 @@
 			FrameUtils.DisplayFrame(toLoad);
 		} else {
-			FrameGraphics.ErrorMessage(toLoad + " is not a valid frame name.");
+			MessageBay.errorMessage(toLoad + " is not a valid frame name.");
 		}
 	}
@@ -1844,5 +1844,5 @@
 		// repaint things if necessary
 		if (Frame.itemAttachedToCursor())
-			move(Frame.FreeItems);
+			move(FreeItems.getInstance());
 	}
 
@@ -1921,6 +1921,6 @@
 
 		if (attribs == null)
-			FrameGraphics
-					.DisplayMessage("All attributes of that item are default values.");
+			MessageBay
+					.displayMessage("All attributes of that item are default values.");
 		else {
 			// Give the attribute text item the color of the item for which
@@ -1946,16 +1946,16 @@
 		if (Frame.itemAttachedToCursor()) {
 			// if this is an item-swap
-			if (Frame.FreeItems.size() == 1
-					&& Frame.FreeItems.get(0) instanceof Text
+			if (FreeItems.getInstance().size() == 1
+					&& FreeItems.getInstance().get(0) instanceof Text
 					&& toDelete != null && toDelete instanceof Text) {
 
 				// check permissions
 				if (!toDelete.hasPermission(Permission.full)) {
-					FrameGraphics
-							.DisplayMessage("Insufficient permission to swap Item text");
+					MessageBay
+							.displayMessage("Insufficient permission to swap Item text");
 					return;
 				}
 				Text anchored = (Text) toDelete;
-				Text free = (Text) Frame.FreeItems.get(0);
+				Text free = (Text) FreeItems.getInstance().get(0);
 				SessionStats.DeletedItem(free);
 				// List<String> temp = anchored.getText();
@@ -1963,5 +1963,5 @@
 
 				// free.setTextList(temp);
-				Frame.FreeItems.clear();
+				FreeItems.getInstance().clear();
 
 				anchored.getParent().setChanged(true);
@@ -1972,5 +1972,5 @@
 				_offY = getY() - anchored.getY() + anchored.getOffset().y;
 			} else {
-				deleteItems(Frame.FreeItems);
+				deleteItems(FreeItems.getInstance());
 			}
 			// reset the mouse cursor
@@ -2032,6 +2032,6 @@
 			// check permissions
 			if (!toDelete.hasPermission(Permission.full)) {
-				FrameGraphics
-						.DisplayMessage("Insufficient permission to delete item");
+				MessageBay
+						.displayMessage("Insufficient permission to delete item");
 				return;
 			}
@@ -2355,6 +2355,6 @@
 
 		if (!toGrab.hasPermission(Permission.full)) {
-			FrameGraphics
-					.DisplayMessage("Insufficient permission pickup the item");
+			MessageBay
+					.displayMessage("Insufficient permission pickup the item");
 			return;
 		}
@@ -2402,5 +2402,5 @@
 					i.setParent(null);
 			}
-			Frame.FreeItems.add(i);
+			FreeItems.getInstance().add(i);
 			i.setFloating(true);
 			if (i.hasVector()) {
@@ -2409,5 +2409,5 @@
 				// Collection<Item> copies = ItemUtils.CopyItems(overlayFrame
 				// .getNonAnnotationItems(), i.getVector());
-				// Frame.FreeItems.addAll(copies);
+				// FreeItems.getInstance().addAll(copies);
 				// TODO add the copies to the free items so they are visible
 				// when the cursor is moving around but are not anchored
@@ -2429,12 +2429,12 @@
 					// make the offset item the first item in the list (so
 					// move method knows which item to use)
-					Frame.FreeItems.set(Frame.FreeItems.indexOf(i),
-							Frame.FreeItems.get(0));
-					Frame.FreeItems.set(0, i);
+					FreeItems.getInstance().set(FreeItems.getInstance().indexOf(i),
+							FreeItems.getInstance().get(0));
+					FreeItems.getInstance().set(0, i);
 					break;
 				}
 			}
 
-			move(Frame.FreeItems);
+			move(FreeItems.getInstance());
 			ItemUtils.EnclosedCheck(toGrab);
 			// otherwise, just use the first item
@@ -2448,6 +2448,6 @@
 			move(toGrab);
 		} else {
-			FrameGraphics
-					.DisplayMessage("Insufficient permission pickup the items");
+			MessageBay
+					.displayMessage("Insufficient permission pickup the items");
 		}
 		if (bReparse)
@@ -2536,14 +2536,14 @@
 		int clicks = arg0.getClickCount();
 
-		if (Frame.FreeItems.size() == 2) {
-			if ((Frame.FreeItems.get(0).isLineEnd() && Frame.FreeItems.get(1) instanceof Line)
-					|| (Frame.FreeItems.get(1).isLineEnd() && Frame.FreeItems
+		if (FreeItems.getInstance().size() == 2) {
+			if ((FreeItems.getInstance().get(0).isLineEnd() && FreeItems.getInstance().get(1) instanceof Line)
+					|| (FreeItems.getInstance().get(1).isLineEnd() && FreeItems.getInstance()
 							.get(0) instanceof Line)) {
 
 				Line line;
-				if (Frame.FreeItems.get(0) instanceof Line)
-					line = (Line) Frame.FreeItems.get(0);
+				if (FreeItems.getInstance().get(0) instanceof Line)
+					line = (Line) FreeItems.getInstance().get(0);
 				else
-					line = (Line) Frame.FreeItems.get(1);
+					line = (Line) FreeItems.getInstance().get(1);
 
 				// User must do multiple clicks to toggle the line
@@ -2590,6 +2590,6 @@
 				// check permissions
 				if (!item.hasPermission(Permission.full)) {
-					FrameGraphics
-							.DisplayMessage("Insufficient permission to edit the Line");
+					MessageBay
+							.displayMessage("Insufficient permission to edit the Line");
 					return;
 				}
Index: /trunk/src/org/expeditee/gui/FrameUtils.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameUtils.java	(revision 120)
+++ /trunk/src/org/expeditee/gui/FrameUtils.java	(revision 121)
@@ -331,5 +331,5 @@
 		if (Frame.itemAttachedToCursor()) {
 			List<Item> toAdd = new ArrayList<Item>();
-			List<Item> toCheck = new ArrayList<Item>(Frame.FreeItems);
+			List<Item> toCheck = new ArrayList<Item>(FreeItems.getInstance());
 
 			while (toCheck.size() > 0) {
@@ -339,6 +339,6 @@
 				// // Only move completely enclosed items
 				// if (!toCheck.containsAll(connected)) {
-				// connected.retainAll(Frame.FreeItems);
-				// Frame.FreeItems.removeAll(connected);
+				// connected.retainAll(FreeItems.getInstance());
+				// FreeItems.getInstance().removeAll(connected);
 				// toCheck.removeAll(connected);
 				// FrameMouseActions.anchor(connected);
@@ -349,5 +349,5 @@
 				// Anchor overlay items where they belong
 				if (i.getParent() != null && i.getParent() != current) {
-					Frame.FreeItems.removeAll(connected);
+					FreeItems.getInstance().removeAll(connected);
 					toCheck.removeAll(connected);
 					FrameMouseActions.anchor(connected);
@@ -357,5 +357,5 @@
 					toCheck.removeAll(connected);
 					// Dont add the items that are free
-					connected.removeAll(Frame.FreeItems);
+					connected.removeAll(FreeItems.getInstance());
 					toAdd.addAll(connected);
 				}
@@ -376,5 +376,5 @@
 		// if the saving happened properly, we can continue
 		if (!LeavingFrame(current)) {
-			FrameGraphics.DisplayMessage("Navigation cancelled");
+			MessageBay.displayMessage("Navigation cancelled");
 			return;
 		}
@@ -437,5 +437,5 @@
 
 		if (f == null) {
-			FrameGraphics.ErrorMessage("Frame '" + frameName
+			MessageBay.errorMessage("Frame '" + frameName
 					+ "' could not be found.");
 		}
@@ -461,7 +461,7 @@
 			if (imagePath.length() == 0) {
 				return false;
-				// FrameGraphics.ErrorMessage("Expected image path after @i:");
+				// MessageBay.errorMessage("Expected image path after @i:");
 			} else {
-				FrameGraphics.ErrorMessage("Image " + imagePath
+				MessageBay.errorMessage("Image " + imagePath
 						+ " could not be loaded");
 			}
@@ -506,14 +506,11 @@
 		} catch (InteractiveWidgetNotAvailableException e) {
 			e.printStackTrace();
-			FrameGraphics.ErrorMessage("Cannot create iWidget: "
-					+ e.getMessage());
+			MessageBay.errorMessage("Cannot create iWidget: " + e.getMessage());
 		} catch (InteractiveWidgetInitialisationFailedException e) {
 			e.printStackTrace();
-			FrameGraphics.ErrorMessage("Cannot create iWidget: "
-					+ e.getMessage());
+			MessageBay.errorMessage("Cannot create iWidget: " + e.getMessage());
 		} catch (IllegalArgumentException e) {
 			e.printStackTrace();
-			FrameGraphics.ErrorMessage("Cannot create iWidget: "
-					+ e.getMessage());
+			MessageBay.errorMessage("Cannot create iWidget: " + e.getMessage());
 		}
 
@@ -557,5 +554,5 @@
 				// warn the user
 				else {
-					// FrameGraphics.WarningMessage("Home frame: " + first
+					// MessageBay.warningMessage("Home frame: " + first
 					// + " is not a valid frame.");
 					UserSettings.FirstFrame = profile.getName();
@@ -627,5 +624,5 @@
 				UserSettings.FrameDirs.addAll(getDirs(item));
 			} else {
-				FrameGraphics.WarningMessage(attributeFullCase
+				MessageBay.warningMessage(attributeFullCase
 						+ " is not a profile frame tag");
 			}
@@ -636,15 +633,15 @@
 		if (UserSettings.FirstFrame == null)
 			UserSettings.FirstFrame = profile.getName();
-		else {
-			Frame firstFrame = FrameIO.LoadFrame(UserSettings.FirstFrame);
-			if (firstFrame == null) {
-				FrameGraphics.WarningMessage("Home frame not found: "
-						+ UserSettings.FirstFrame);
-				UserSettings.FirstFrame = profile.getName();
-				DisplayIO.setCurrentFrame(profile);
-			} else {
-				DisplayIO.setCurrentFrame(firstFrame);
-			}
-		}
+		// else {
+		Frame firstFrame = FrameIO.LoadFrame(UserSettings.FirstFrame);
+		if (firstFrame == null) {
+			MessageBay.warningMessage("Home frame not found: "
+					+ UserSettings.FirstFrame);
+			UserSettings.FirstFrame = profile.getName();
+			DisplayIO.setCurrentFrame(profile);
+		} else {
+			DisplayIO.setCurrentFrame(firstFrame);
+		}
+		// }
 	}
 
@@ -727,8 +724,8 @@
 					return name + File.separator;
 			} else {
-				FrameGraphics.ErrorMessage("Directory not found: " + name);
+				MessageBay.errorMessage("Directory not found: " + name);
 			}
 		} else {
-			FrameGraphics.WarningMessage("Missing value for profile attribute"
+			MessageBay.warningMessage("Missing value for profile attribute"
 					+ name);
 		}
@@ -866,5 +863,6 @@
 						}
 					}// check for new VECTOR items
-					else if (ItemUtils.startsWithTag(i, ItemUtils.TAG_VECTOR)
+					else if (!FrameGraphics.isXRayMode()
+							&& ItemUtils.startsWithTag(i, ItemUtils.TAG_VECTOR)
 							&& i.getLink() != null) {
 						// TODO It is possible to get into an infinate loop if a
@@ -879,6 +877,7 @@
 						vectorPermission = Permission.min(vectorPermission,
 								permission);
-						//Highest permissable permission for vectors is copy
-						vectorPermission = Permission.min(vectorPermission, Permission.copy);
+						// Highest permissable permission for vectors is copy
+						vectorPermission = Permission.min(vectorPermission,
+								Permission.copy);
 						if (vector != null) {
 							String scaleString = AttributeUtils
@@ -889,7 +888,7 @@
 							} catch (Exception e) {
 							}
-							Vector newVector = new Vector(vector, vectorPermission, i
-									.getPosition(), scale, i.getColor(), i
-									.getBackgroundColor());
+							Vector newVector = new Vector(vector,
+									vectorPermission, i.getPosition(), scale, i
+											.getColor(), i.getBackgroundColor());
 							i.setOverlay(newVector);
 							vectors.add(newVector);
@@ -903,5 +902,5 @@
 							// This frame contains an active overlay which
 							// points to itself
-							FrameGraphics.ErrorMessage(toParse.getName()
+							MessageBay.errorMessage(toParse.getName()
 									+ " contains an @o which links to itself");
 							continue;
@@ -921,5 +920,5 @@
 							// This frame contains an active overlay which
 							// points to itself
-							FrameGraphics.ErrorMessage(toParse.getName()
+							MessageBay.errorMessage(toParse.getName()
 									+ " contains an @ao which links to itself");
 							continue;
@@ -1054,5 +1053,5 @@
 				Logger.Log(e);
 				e.printStackTrace();
-				FrameGraphics.WarningMessage("Exception occured when loading "
+				MessageBay.warningMessage("Exception occured when loading "
 						+ i.getClass().getSimpleName() + "(ID: " + i.getID()
 						+ ") " + e.getMessage());
@@ -1100,5 +1099,5 @@
 		if (y > FrameGraphics.getMaxFrameSize().getHeight()) {
 			// check the individual message items
-			for (Item message : FrameGraphics.Messages) {
+			for (Item message : MessageBay.getMessages()) {
 				if (message != null) {
 					if (message.contains(x, y)) {
@@ -1114,8 +1113,8 @@
 
 			// check the link to the message frame
-			if (FrameGraphics.MessageLink != null) {
-				if (FrameGraphics.MessageLink.contains(x, y)) {
-					FrameGraphics.MessageLink.setPermission(Permission.copy);
-					possibles.add(FrameGraphics.MessageLink);
+			if (MessageBay.getMessageLink() != null) {
+				if (MessageBay.getMessageLink().contains(x, y)) {
+					MessageBay.getMessageLink().setPermission(Permission.copy);
+					possibles.add(MessageBay.getMessageLink());
 				}
 			}
@@ -1128,5 +1127,5 @@
 										 * LastEdited.isVisible() &&
 										 */LastEdited.contains(x, y)
-					&& !Frame.FreeItems.contains(LastEdited)
+					&& !FreeItems.getInstance().contains(LastEdited)
 					&& LastEdited.getParent() == DisplayIO.getCurrentFrame()
 					&& LastEdited.getParent().getItems().contains(LastEdited)) {
@@ -1141,6 +1140,8 @@
 			for (Item i : checkList) {
 				// do not check annotation items in audience mode
-				if (i.isVisible() && !(FrameGraphics.isAudienceMode() && i.isAnnotation())) {
-					if (i.contains(x, y) && !Frame.FreeItems.contains(i)) {
+				if (i.isVisible()
+						&& !(FrameGraphics.isAudienceMode() && i.isAnnotation())) {
+					if (i.contains(x, y)
+							&& !FreeItems.getInstance().contains(i)) {
 						possibles.add(i);
 					}
@@ -1232,5 +1233,5 @@
 
 		// Remove all items that are connected to freeItems
-		List<Item> freeItems = new ArrayList<Item>(Frame.FreeItems);
+		List<Item> freeItems = new ArrayList<Item>(FreeItems.getInstance());
 		while (freeItems.size() > 0) {
 			Item item = freeItems.get(0);
Index: /trunk/src/org/expeditee/io/AbstractHTMLWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/AbstractHTMLWriter.java	(revision 120)
+++ /trunk/src/org/expeditee/io/AbstractHTMLWriter.java	(revision 121)
@@ -5,5 +5,5 @@
 
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Item;
 
@@ -39,5 +39,5 @@
 					dir.mkdirs();
 				} catch (Exception e) {
-					FrameGraphics.ErrorMessage("Could not create folder: "
+					MessageBay.errorMessage("Could not create folder: "
 							+ dir.getName());
 					_filesFolderName = null;
Index: /trunk/src/org/expeditee/io/DefaultTreeWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/DefaultTreeWriter.java	(revision 120)
+++ /trunk/src/org/expeditee/io/DefaultTreeWriter.java	(revision 121)
@@ -6,6 +6,6 @@
 
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
@@ -91,5 +91,5 @@
 				this.resumeFrame(next);
 			} else {
-				FrameGraphics.OverwriteMessage("Writing: " + next.getName());
+				MessageBay.overwriteMessage("Writing: " + next.getName());
 				_frameCount++;
 				writeStartFrame(next);
